const gulp = require('gulp');
const uglify = require('gulp-uglify');
const pump = require('pump');
const plumber = require('gulp-plumber');
const rename = require('gulp-rename');
const babelify = require('gulp-babel');

var build_task = function() {
  pump([
    plumber({
      errorHandler: function(err) {
        console.log(err);
        this.emit('end');
      }
    }),
    gulp.src('lib/main.js'),
    babelify({presets: [[
      'env', {
        targets: {
          browsers: ['last 5 major versions', 'not ie <= 8']
        }
      }
    ]]}),
    uglify(),
    rename('couchdb-wrapper.min.js'),
    gulp.dest('dist/')
  ]);
}
gulp.task('build-for-web',build_task);

var copy_externals = function() {
  pump([
    plumber({
      errorHandler: function(err) {
        console.log(err);
        this.emit('end');
      }
    }),
    gulp.src('lib/externals/*.js'),
    gulp.dest('dist/externals/')
  ]);
}
gulp.task('copy-externals',copy_externals);

gulp.task('default',function() {
  gulp.watch('lib/main.js',['build-for-web']);
  gulp.watch('lib/externals/*.js',['copy-externals']);

  build_task();
  copy_externals();
});
